

<!DOCTYPE html>
<html lang="en">

<head>
  
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title> models/task.model.js</title>

  <script src="https://cdn.jsdelivr.net/gh/google/code-prettify@master/loader/run_prettify.js"></script>
  <script src="https://unpkg.com/@babel/standalone/babel.min.js"></script>
  <script src="./build/entry.js"></script>
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <!--[if lt IE 9]>
    <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
  <![endif]-->
  <link href="https://fonts.googleapis.com/css?family=Roboto:100,400,700|Inconsolata,700" rel="stylesheet">
  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.6.3/css/all.css" integrity="sha384-UHRtZLI+pbxtHCWp1t77Bi1L4ZtiqrqD80Kn4Z8NTSRyMA2Fd33n5dQ8lWUE00s/" crossorigin="anonymous">
  <link type="text/css" rel="stylesheet" href="https://jmblog.github.io/color-themes-for-google-code-prettify/themes/tomorrow-night.min.css">
  <link type="text/css" rel="stylesheet" href="styles/app.min.css">
  <link type="text/css" rel="stylesheet" href="styles/iframe.css">
  <link type="text/css" rel="stylesheet" href="">
  <script async defer src="https://buttons.github.io/buttons.js"></script>

  
</head>



<body class="layout small-header">
    <div id="stickyNavbarOverlay"></div>
    

<div class="top-nav">
    <div class="inner">
        <a id="hamburger" role="button" class="navbar-burger" aria-label="menu" aria-expanded="false">
            <span aria-hidden="true"></span>
            <span aria-hidden="true"></span>
            <span aria-hidden="true"></span>
        </a>
        <div class="logo">
            
            
        </div>
        <div class="menu">
            
            <div class="navigation">
                <a
                    href="index.html"
                    class="link"
                >
                    API Documentation
                </a>
                
                
                
            </div>
        </div>
    </div>
</div>
    <div id="main">
        <div
            class="sidebar "
            id="sidebarNav"
        >
            
            <nav>
                
                    <h2><a href="index.html">Documentation</a></h2><div class="category"><h3>Classes</h3><ul><li><a href="Board.html">Board</a></li><li><a href="Task.html">Task</a></li></ul><h3>Global</h3><ul><li><a href="global.html#status">status</a></li></ul></div>
                
            </nav>
        </div>
        <div class="core" id="main-content-wrapper">
            <div class="content">
                <header class="page-title">
                    <p>Source</p>
                    <h1>models/task.model.js</h1>
                </header>
                



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>import { status } from '../common/status.enum.js';

/** The Task class holds all relevant data and behavior a task might have. */
export class Task {
  // One way to indicate that a field should not be touched is to put an underscore before its name.
  // This won't prevent your colleges from directly interacting with it.

  #name;
  #dueDate;
  #status;
  static #NAME_MIN_LENGTH = 6;
  static #NAME_MAX_LENGTH = 20;

  /**
    * Creates an instance of the Task class.
    * @param {string} name - The name of the task.
    * @param {Date} dueDate - The due date of the task.
    */
  constructor(name, dueDate) {
    this.name = name;
    this.dueDate = dueDate;
    this.status = status.TODO;
  }

  /**
     * Gets the name of the task.
     * @returns {string} The name of the task.
     */
  get name() {
    return this.#name;
  }

  /**
     * Sets the name of the task.
     * @param {string} value - The new name for the task.
     * @throws {Error} If the name is empty or its length is outside the specified range.
     */
  set name(value) {
    if (!value) {
      throw Error('Name cannot be empty!');
    }

    if (value.length &lt; Task.#NAME_MIN_LENGTH || value.length > Task.#NAME_MAX_LENGTH) {
      // eslint-disable-next-line quotes
      throw Error(`Name should be between ${Task.#NAME_MIN_LENGTH} and ${Task.#NAME_MAX_LENGTH} symbols`);
    }
    this.#name = value;
  }

  /**
  * Gets the due date of the task.
  * @returns {Date} The due date of the task.
  */
  get dueDate() {
    return this.#dueDate;
  }

  /**
     * Sets the due date of the task.
     * @param {Date} value - The new due date for the task.
     * @throws {Error} If the date is empty or earlier than the current date.
     */
  set dueDate(value) {
    if (!value) {
      throw Error('Date cannot be empty!');
    }
    if (value.valueOf() &lt; Date.now().valueOf()) {
      throw Error('Due date cannot be earlier than today');
    }
    this.#dueDate = value;
  }

  /**
    * Gets the status of the task.
    * @returns {string} The status of the task.
    */
  get status() {
    return this.#status;
  }
  
  /**
   * Sets the status of the task.
   * @param {string} value - The new status for the task.
   * @throws {Error} If the status is not a valid value.
   */
  set status(value) {
    if (!Object.values(status).includes(value)) {
      throw new Error('Invalid status.');
    }
    this.#status = value
  }

  /** Sets the task status to TODO. */
  reset() {
    this.status = status.TODO;
  }

  /** Sets the task status to IN_PROGRESS. */
  advance() {
    this.status = status.IN_PROGRESS;
  }

  /** Sets the task status to DONE. */
  complete() {
    this.status = status.DONE;
  }

  /** Transforms the task data into a formatted string */
  toString() {
    return `Name: ${this.#name}\n` +
      `Status: ${this.#status}\n` +
      `Due: ${this.#dueDate.toLocaleDateString()} ${this.#dueDate.toLocaleTimeString()}`;
  }
}
</code></pre>
        </article>
    </section>




            </div>
            
            <footer class="footer">
                <div class="content has-text-centered">
                    <p>Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a></p>
                    <p class="sidebar-created-by">
                        <a href="https://github.com/SoftwareBrothers/better-docs" target="_blank">BetterDocs theme</a> provided with <i class="fas fa-heart"></i> by 
                        <a href="http://softwarebrothers.co" target="_blank">SoftwareBrothers - JavaScript Development Agency</a>
                    </p>
                </div>
            </footer>
            
        </div>
        <div id="side-nav" class="side-nav">
        </div>
    </div>
<script src="scripts/app.min.js"></script>
<script>PR.prettyPrint();</script>
<script src="scripts/linenumber.js"> </script>

</body>
</html>
